%define up_name		freerdp

%define winpr_major	3
%define uwac_major	0
%define rdtk_major	0
%define major		3
%define libname		%mklibname freerdp3_ %{major}
%define libname_client	%mklibname freerdp-client3_ %{major}
%define libname_server	%mklibname freerdp-server3_ %{major}
%define libname_proxy	%mklibname freerdp-server-proxy3_ %{major}
%define libname_shadow	%mklibname freerdp-shadow3_ %{major}
%define libname_subsys	%mklibname freerdp-shadow-subsystem3_ %{major}
%define libname_rdtk	%mklibname rdtk0_ %{rdtk_major}
%define libname_uwac	%mklibname uwac0_ %{uwac_major}
%define libname_winpr	%mklibname winpr3_ %{winpr_major}
%define libname_winpr_t	%mklibname winpr-tools3_ %{winpr_major}
%define develname	%mklibname %{name} -d

# Momentarily disable GSS support (mga#32100)
# https://github.com/FreeRDP/FreeRDP/issues/4348
%bcond_with gss

Name:		freerdp3
Version:	3.16.0
Release:	%mkrel 2
Summary:	A free remote desktop protocol client
License:	Apache License
Group:		Networking/Remote access
Url:		https://www.freerdp.com/
Source0:	https://pub.freerdp.com/releases/%{up_name}-%{version}.tar.gz
Patch0:		freerdp3-fix-desktop-file.patch

BuildRequires:	cmake
BuildRequires:	docbook-style-xsl
BuildRequires:	xmlto
BuildRequires:	icu-devel
BuildRequires:	ffmpeg-devel
BuildRequires:	gsm-devel
BuildRequires:	lame-devel
BuildRequires:	cmake(SDL3)
BuildRequires:	cmake(SDL3_image)
BuildRequires:	cmake(SDL3_ttf)
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(cairo)
BuildRequires:	pkgconfig(cups)
BuildRequires:	pkgconfig(fdk-aac)
BuildRequires:	pkgconfig(fuse3)
BuildRequires:	pkgconfig(libcjson)
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	pkgconfig(libpkcs11-helper-1)
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig(liburiparser)
BuildRequires:	pkgconfig(OpenCL)
BuildRequires:	pkgconfig(openssl)
BuildRequires:	pkgconfig(opus)
BuildRequires:	pkgconfig(soxr)
BuildRequires:	pkgconfig(xcursor)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xkbfile)
BuildRequires:	pkgconfig(xv)
BuildRequires:	pkgconfig(x11)
BuildRequires:	pam-devel
BuildRequires:	pkgconfig(gstreamer-1.0)
BuildRequires:	pkgconfig(gstreamer-base-1.0)
BuildRequires:	pkgconfig(gstreamer-app-1.0)
BuildRequires:	pkgconfig(gstreamer-audio-1.0)
BuildRequires:	pkgconfig(gstreamer-fft-1.0)
BuildRequires:	pkgconfig(gstreamer-pbutils-1.0)
BuildRequires:	pkgconfig(gstreamer-video-1.0)
%if %{with gss}
BuildRequires:	pkgconfig(krb5) >= 1.13
%endif
BuildRequires:	pkgconfig(libpcsclite)
BuildRequires:	pkgconfig(libsystemd)
BuildRequires:	pkgconfig(libusb-1.0)
BuildRequires:	pkgconfig(xdamage)
BuildRequires:	pkgconfig(wayland-client)
BuildRequires:	pkgconfig(wayland-scanner)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xi)
BuildRequires:	pkgconfig(xkbcommon)
BuildRequires:	pkgconfig(zlib)

%description
FreeRDP is a fork of the rdesktop project.

#----------------------------------------------------

%package sdl
Summary:	SDL3 Client support for %{name}
Group:		System/Libraries
Requires:	%{name} >= %{version}

%description sdl
This package provides the sdl-based client application.

#----------------------------------------------------

%package -n	%{libname}
Summary:	Main library for %{name}
Group:		System/Libraries

%description -n	%{libname}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_client}
Summary:	Client library for %{name}
Group:		System/Libraries

%description -n	%{libname_client}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_server}
Summary:	Server library for %{name}
Group:		System/Libraries

%description -n	%{libname_server}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_proxy}
Summary:	Server Proxy library for %{name}
Group:		System/Libraries

%description -n	%{libname_proxy}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_shadow}
Summary:	Shadow library for %{name}
Group:		System/Libraries

%description -n	%{libname_shadow}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_subsys}
Summary:	Shadow subsystem library for %{name}
Group:		System/Libraries

%description -n	%{libname_subsys}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_rdtk}
Summary:	Rdtk library for %{name}
Group:		System/Libraries

%description -n	%{libname_rdtk}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_uwac}
Summary:	Uwac library for %{name}
Group:		System/Libraries

%description -n	%{libname_uwac}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_winpr}
Summary:	WinPR library for %{name}
Group:		System/Libraries

%description -n	%{libname_winpr}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{libname_winpr_t}
Summary:	WinPR Tools library for %{name}
Group:		System/Libraries

%description -n	%{libname_winpr_t}
Shared libraries for %{name}.

#----------------------------------------------------

%package -n	%{develname}
Summary:	Development files for %{name}
Group:		Development/C++
Requires:	%{name} = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Requires:	%{libname_client} = %{version}-%{release}
Requires:	%{libname_server} = %{version}-%{release}
Requires:	%{libname_proxy} = %{version}-%{release}
Requires:	%{libname_shadow} = %{version}-%{release}
Requires:	%{libname_subsys} = %{version}-%{release}
Requires:	%{libname_rdtk} = %{version}-%{release}
Requires:	%{libname_uwac} = %{version}-%{release}
Requires:	%{libname_winpr} = %{version}-%{release}
Requires:	%{libname_winpr_t} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	rdtk-devel = %{version}-%{release}
Provides:	uwac-devel = %{version}-%{release}
Provides:	winpr-devel = %{version}-%{release}

%description -n	%{develname}
Development files and headers for %{name}.

#----------------------------------------------------

%prep
%autosetup -p1 -n %{up_name}-%{version}

%build
%cmake \
    -DCMAKE_SKIP_INSTALL_RPATH=ON \
    -DCMAKE_INSTALL_LIBDIR:PATH=%{_lib} \
    -DCHANNEL_URBDRC=ON \
    -DCHANNEL_URBDRC_CLIENT=ON \
    -DWITH_ALSA=ON \
    -DWITH_AAD=ON \
    -DWITH_CAIRO=ON \
    -DWITH_CUPS=ON \
    -DWITH_CHANNELS=ON \
    -DWITH_CLIENT=ON \
    -DWITH_CLIENT_SDL=ON \
    -DWITH_CLIENT_SDL_VERSIONED=OFF \
    -DWITH_CLIENT_SDL3=ON \
    -DWITH_CLIENT_SDL2=OFF \
    -DWITH_DIRECTFB=OFF \
    -DWITH_DSP_FFMPEG=ON \
    -DWITH_FDK_AAC=ON \
    -DWITH_FFMPEG=ON \
    -DWITH_FUSE=ON \
    -DWITH_GSM=ON \
    -DWITH_GSSAPI=%{?with_gss:ON}%{?!with_gss:OFF} \
    -DWITH_KRB5=%{?with_gss:ON}%{?!with_gss:OFF} \
    -DWITH_GSTREAMER_1_0=ON -DWITH_GSTREAMER_0_10=OFF \
    -DWITH_INSTALL_CLIENT_DESKTOP_FILES=ON \
    -DWITH_IPP=OFF \
    -DWITH_JPEG=ON \
    -DWITH_JSONC_REQUIRED=ON \
    -DWITH_KEYBOARD_LAYOUT_FROM_FILE=ON \
    -DWITH_LAME=ON \
    -DWITH_MANPAGES=ON \
    -DWITH_OPENCL=ON \
    -DWITH_OPENSSL=ON \
    -DWITH_OPUS=ON \
    -DWITH_PCSC=ON \
    -DWITH_PULSE=ON \
    -DWITH_SAMPLE=ON \
    -DWITH_SDL_IMAGE_DIALOGS=ON \
    -DWITH_SERVER=ON -DWITH_SERVER_INTERFACE=ON \
    -DWITH_SHADOW_X11=ON -DWITH_SHADOW_MAC=ON \
    -DWITH_SOXR=ON \
    -DWITH_SWSCALE=ON \
    -DWITH_TIMEZONE_COMPILED=OFF \
    -DWITH_TIMEZONE_FROM_FILE=ON \
    -DWITH_VERBOSE_WINPR_ASSERT=OFF \
    -DWITH_WAYLAND=ON \
    -DWITH_X11=ON \
    -DWITH_XCURSOR=ON \
    -DWITH_XEXT=ON \
    -DWITH_XKBFILE=ON \
    -DWITH_XI=ON \
    -DWITH_XINERAMA=ON \
    -DWITH_XRENDER=ON \
    -DWITH_XTEST=OFF \
    -DWITH_XV=ON \
    -DWITH_ZLIB=ON \
%ifarch x86_64
    -DWITH_SIMD=ON \
%else
    -DWITH_SIMD=OFF \
%endif
%ifarch armv7hl
    -DARM_FP_ABI=hard \
    -DWITH_NEON=OFF \
    -DWINPR_HAVE_UNWIND_H=OFF \
%endif
%ifarch armv7hnl
    -DARM_FP_ABI=hard \
    -DWITH_NEON=ON \
%endif
%ifarch armv5tl armv5tel armv6l armv7l
    -DARM_FP_ABI=soft \
    -DWITH_NEON=OFF \
%endif
    -DWINPR_UTILS_IMAGE_PNG=ON \
    -DWINPR_UTILS_IMAGE_WEBP=ON \
    -DWINPR_UTILS_IMAGE_JPEG=ON

%cmake_build

%install
%cmake_install

%files
%doc ChangeLog README.md
%license LICENSE
%{_bindir}/freerdp-proxy
%{_bindir}/freerdp-shadow-cli
%{_bindir}/sfreerdp
%{_bindir}/sfreerdp-server
%{_bindir}/winpr-hash
%{_bindir}/winpr-makecert
%{_bindir}/wlfreerdp
%{_bindir}/xfreerdp
%{_datadir}/FreeRDP/
%{_datadir}/WinPR/
%{_libdir}/%{name}/
%{_datadir}/applications/sfreerdp*.desktop
%{_datadir}/applications/xfreerdp*.desktop
%{_iconsdir}/hicolor/scalable/apps/FreeRDP.svg
%{_mandir}/man1/xfreerdp.1.*
%{_mandir}/man1/freerdp-proxy.1.*
%{_mandir}/man1/freerdp-shadow-cli.1.*
%{_mandir}/man1/winpr-hash.1.*
%{_mandir}/man1/winpr-makecert.1.*
%{_mandir}/man1/wlfreerdp.1.*
%{_mandir}/man7/wlog.7.*

%files sdl
%{_bindir}/sdl-freerdp
%{_datadir}/applications/sdl-freerdp*.desktop
%{_mandir}/man1/sdl-freerdp.1.*

%files -n %{libname}
%doc ChangeLog README.md
%license LICENSE
%{_libdir}/lib%{name}.so.%{major}{,.*}

%files -n %{libname_client}
%license LICENSE
%{_libdir}/libfreerdp-client3.so.%{major}{,.*}

%files -n %{libname_server}
%license LICENSE
%{_libdir}/libfreerdp-server3.so.%{major}{,.*}

%files -n %{libname_proxy}
%license LICENSE
%{_libdir}/libfreerdp-server-proxy3.so.%{major}{,.*}

%files -n %{libname_shadow}
%license LICENSE
%{_libdir}/libfreerdp-shadow3.so.%{major}{,.*}

%files -n %{libname_subsys}
%license LICENSE
%{_libdir}/libfreerdp-shadow-subsystem3.so.%{major}{,.*}

%files -n %{libname_rdtk}
%license LICENSE
%{_libdir}/librdtk0.so.%{rdtk_major}{,.*}

%files -n %{libname_uwac}
%license LICENSE
%{_libdir}/libuwac0.so.%{uwac_major}{,.*}

%files -n %{libname_winpr}
%license LICENSE
%{_libdir}/libwinpr3.so.%{winpr_major}{,.*}

%files -n %{libname_winpr_t}
%license LICENSE
%{_libdir}/libwinpr-tools3.so.%{winpr_major}{,.*}

%files -n %{develname}
%doc ChangeLog README.md
%{_libdir}/lib*.so
%{_includedir}/%{name}/
%{_includedir}/winpr3/
%{_includedir}/uwac0/
%{_includedir}/rdtk0/
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/pkgconfig/freerdp-client3.pc
%{_libdir}/pkgconfig/freerdp-server-proxy3.pc
%{_libdir}/pkgconfig/freerdp-server3.pc
%{_libdir}/pkgconfig/freerdp-shadow3.pc
%{_libdir}/pkgconfig/winpr*.pc
%{_libdir}/pkgconfig/uwac*.pc
%{_libdir}/pkgconfig/rdtk*.pc
%{_libdir}/cmake/FreeRDP*/
%{_libdir}/cmake/WinPR*/
%{_libdir}/cmake/uwac*/
%{_libdir}/cmake/rdtk*/


%changelog
* Mon Jul 07 2025 daviddavid <daviddavid> 3.16.0-2.mga10
+ Revision: 2250459
- rebuild for new fuse3 3.17.2

* Mon Jun 16 2025 daviddavid <daviddavid> 3.16.0-1.mga10
+ Revision: 2192090
- new version: 3.16.0

* Sun Jun 01 2025 daviddavid <daviddavid> 3.15.0-3.mga10
+ Revision: 2187745
- do not conflict libfreerdp2 anymore

* Sat May 17 2025 daviddavid <daviddavid> 3.15.0-2.mga10
+ Revision: 2184066
- enable sdl3 client support
- enable fdk-aac-free support

* Tue Apr 15 2025 daviddavid <daviddavid> 3.15.0-1.mga10
+ Revision: 2175681
- new version: 3.15.0

* Wed Mar 26 2025 daviddavid <daviddavid> 3.14.1-1.mga10
+ Revision: 2169978
- new version: 3.14.1

* Thu Mar 13 2025 daviddavid <daviddavid> 3.14.0-1.mga10
+ Revision: 2163265
- new version: 3.14.0

* Fri Mar 07 2025 daviddavid <daviddavid> 3.13.0-1.mga10
+ Revision: 2161672
- new version: 3.13.0

* Sat Feb 15 2025 daviddavid <daviddavid> 3.12.0-1.mga10
+ Revision: 2148958
- new version: 3.12.0

* Sat Feb 08 2025 daviddavid <daviddavid> 3.11.1-1.mga10
+ Revision: 2146050
- new version: 3.11.1

* Fri Jan 24 2025 daviddavid <daviddavid> 3.10.3-1.mga10
+ Revision: 2141340
- new version: 3.10.3

* Sun Jan 12 2025 wally <wally> 3.10.2-2.mga10
+ Revision: 2138355
- rebuild for icu 76.1

* Mon Dec 16 2024 daviddavid <daviddavid> 3.10.2-1.mga10
+ Revision: 2125655
- new version: 3.10.2

* Thu Dec 12 2024 daviddavid <daviddavid> 3.10.0-1.mga10
+ Revision: 2123686
- new version: 3.10.0

* Sun Dec 08 2024 daviddavid <daviddavid> 3.9.0-2.mga10
+ Revision: 2122899
- rebuild for new ffmpeg 7.1

* Mon Oct 21 2024 daviddavid <daviddavid> 3.9.0-1.mga10
+ Revision: 2109421
- new version: 3.9.0

* Fri Aug 30 2024 daviddavid <daviddavid> 3.8.0-1.mga10
+ Revision: 2092259
- new version: 3.8.0

* Thu Aug 08 2024 daviddavid <daviddavid> 3.7.0-1.mga10
+ Revision: 2084239
- new version: 3.7.0

* Mon Jul 08 2024 daviddavid <daviddavid> 3.6.3-1.mga10
+ Revision: 2080316
- new version: 3.6.3

* Sat Jul 06 2024 daviddavid <daviddavid> 3.6.2-2.mga10
+ Revision: 2080070
- fix build on arvmv7 using -DUSE_UNWIND=OFF compile flags
  https://github.com/FreeRDP/FreeRDP/issues/10353

* Thu Jul 04 2024 daviddavid <daviddavid> 3.6.2-1.mga10
+ Revision: 2079662
- new version: 3.6.2

* Mon Apr 22 2024 daviddavid <daviddavid> 3.5.1-1.mga10
+ Revision: 2060495
- new version: 3.5.1

* Wed Apr 17 2024 daviddavid <daviddavid> 3.5.0-1.mga10
+ Revision: 2058349
- new version: 3.5.0
- remove merged upstream patch

* Tue Apr 09 2024 daviddavid <daviddavid> 3.4.0-2.mga10
+ Revision: 2056141
- backport some more upstream incompatible pointer fixes
- backport upstream patch to fix incompatible PCSC_SCardListReaders pointer

* Thu Mar 14 2024 daviddavid <daviddavid> 3.4.0-1.mga10
+ Revision: 2049877
- new version: 3.4.0

* Thu Feb 22 2024 daviddavid <daviddavid> 3.3.0-1.mga10
+ Revision: 2043278
- new version: 3.3.0

* Fri Feb 09 2024 daviddavid <daviddavid> 3.2.0-2.mga10
+ Revision: 2039815
- fix conflicting files between freerdp2 and freerdp3

* Fri Jan 19 2024 daviddavid <daviddavid> 3.2.0-1.mga10
+ Revision: 2032200
- new version: 3.2.0

* Sun Dec 24 2023 daviddavid <daviddavid> 3.1.0-1.mga10
+ Revision: 2021042
- initial package freerdp3

